﻿import re
import sys
import datetime

def getTime(string):
   match = re.match('(\d{4})-(\d{2})-(\d{2}) (\d{2}):(\d{2}):(\d{2})\.(\d{6})', string)
   if match is not None:
      return datetime.datetime(int(match.group(1)), int(match.group(2)), int(match.group(3)), int(match.group(4)), int(match.group(5)), int(match.group(6)), int(match.group(7)))
   else:
      return None

indent          = 15
deltatimeIndent = 14

if len(sys.argv) < 2:
   print('Usage: {} <hcidump.txt>', sys.argv[0])
   sys.exit(-1)

inputFile = sys.argv[1]

with open(inputFile, 'r') as input:
   direction = None
   lastDirection = None
   time = None
   cycleStartTime = None
   for line in input:
      match = re.match('(.*) < ACL data:', line)
      if match is not None:
         direction = 'send'
         time = getTime(match.group(1))
      else:
         match = re.match('(.*) > ACL data:', line)
         if match is not None:
            direction = 'receive'
            time = getTime(match.group(1))

      match = re.match('\s*(0\d\d\d):\s([\s0-9a-fA-F]{48})', line)
      if match is not None:
         if(direction == 'send' and match.group(1)=='0000'):
            print('\n' + '-' * 80)
         text = ''
         addTime = False
         if lastDirection != direction:
            addTime = True
         for token in match.group(2).split():
            character = chr(int(token, 16))
            if character == '\r':
               text += '\n'
               if direction == 'receive':
                  text += ' '*(indent + len(str(time) + ' | ') + deltatimeIndent + len(' | '))
            else:
               text += character
         command = text
         if addTime:
            if direction == 'receive':
               text = ' '*indent + text
            timeInCycle = ' ' * deltatimeIndent if cycleStartTime is None else str(time - cycleStartTime)
            if time == cycleStartTime:
               timeInCycle += '.000000'
            text = str(time) + ' | ' + timeInCycle + ' | ' + text;
         if command == 'AT SH 7DF\n':
            cycleStartTime = time
         print(text, end='')
         lastDirection = direction
