﻿import re
import csv
import sys

if len(sys.argv) < 2:
   print('Usage: {} <torqueConf.dat>', sys.argv[0])
   sys.exit(-1)
      
outputFile = sys.argv[1]
inputFileSubType = ['general', 'log', 'obd']

with open(outputFile, 'w', newline='\n') as output:
   for subType in inputFileSubType:
      with open(outputFile + '_' + subType + '.csv', 'r') as input:
         index = 0
         mapping = {'Equation'   : 'equation' ,
                    'Name'       : 'fullName' ,
                    'Header'     : 'header'   ,
                    'Max Value'  : 'max'      ,
                    'Min Value'  : 'min'      ,
                    'ModeAndPID' : 'pid'      ,
                    'scale'      : 'scale'    ,
                    'ShortName'  : 'shortName',
                    'Units'      : 'unit'     ,
                    'userpid'    : 'userpid'  ,
                    'varType'    : 'varType'  ,
                    'class'      : 'class'    ,
                    'mode'       : 'mode'     }
         for line in csv.DictReader(input, delimiter=','):
            if line['line']:
               output.write(line['line'] + '\n')
            else:
               for (field, value) in line.items():
                  if field in mapping:
                     if not ((field == 'class' and subType == 'log') or \
                             (field == 'mode' and subType == 'obd') or \
                             (field == 'userpid' and subType == 'obd') or \
                             (field == 'Equation' and not value) or \
                             (field == 'mode' and not value)):
                        valueOut = value if field != 'ModeAndPID' else str(int(value, 16))
                        output.write((subType + '_' if subType != 'general' else '') + mapping[field] + str(index) + '=' + valueOut + '\n')
               index += 1

